| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ChannelInterfaceHoldInterface Class Reference
Channel proxies

`#include <TelepathyQt/Channel>`

Inherits Tp::AbstractInterface.

## Public Slots

QDBusPendingReply< uint, uint > | GetHoldState (int timeout=-1)
QDBusPendingReply | RequestHold (bool hold, int timeout=-1)

## Signals

void | HoldStateChanged (uint holdState, uint reason)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions

| ChannelInterfaceHoldInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelInterfaceHoldInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelInterfaceHoldInterface (Tp::DBusProxy *proxy)
| ChannelInterfaceHoldInterface (const Tp::Client::ChannelInterface &mainInterface)
| ChannelInterfaceHoldInterface (const Tp::Client::ChannelInterface &mainInterface, QObject *parent)
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const

## Additional Inherited Members

Protected Slots inherited from Tp::AbstractInterface

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Interface.Hold".

## Constructor & Destructor Documentation

Tp::Client::ChannelInterfaceHoldInterface::ChannelInterfaceHoldInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelInterfaceHoldInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelInterfaceHoldInterface::ChannelInterfaceHoldInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelInterfaceHoldInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelInterfaceHoldInterface::ChannelInterfaceHoldInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelInterfaceHoldInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::ChannelInterfaceHoldInterface::ChannelInterfaceHoldInterface | ( | const Tp::Client::ChannelInterface & | mainInterface | ) |

explicit

Creates a ChannelInterfaceHoldInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

Tp::Client::ChannelInterfaceHoldInterface::ChannelInterfaceHoldInterface | ( | const Tp::Client::ChannelInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ChannelInterfaceHoldInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::ChannelInterfaceHoldInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.Channel.Interface.Hold", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariantMap* Tp::Client::ChannelInterfaceHoldInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply<uint, uint> Tp::Client::ChannelInterfaceHoldInterface::GetHoldState | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `GetHoldState` on the remote object.

Return whether the local user has placed the channel on hold.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

Returns

      The state of the channel

      The reason why the channel is in that state

QDBusPendingReply Tp::Client::ChannelInterfaceHoldInterface::RequestHold | ( | bool | hold,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `RequestHold` on the remote object.

Request that the channel be put on hold (be instructed not to send any media streams to you) or be taken off hold.

If the connection manager can immediately tell that the requested state change could not possibly succeed, this method SHOULD return the NotAvailable error. If the requested state is the same as the current state, this method SHOULD return successfully without doing anything.

Otherwise, this method SHOULD immediately set the hold state to Local_Hold_State_Pending_Hold or Local_Hold_State_Pending_Unhold (as appropriate), emitting HoldStateChanged() if this is a change, and return successfully.

The eventual success or failure of the request is indicated by a subsequent HoldStateChanged signal, changing the hold state to Local_Hold_State_Held or Local_Hold_State_Unheld.

If the channel has multiple streams, and the connection manager succeeds in changing the hold state of one stream but fails to change the hold state of another, it SHOULD attempt to revert all streams to their previous hold states.

The following state transitions SHOULD be used, where appropriate:

- Successful hold: (Unheld, any reason) → (Pending_Hold, Requested) → (Held, Requested)
- Successful unhold: (Held, any reason) → (Pending_Unhold, Requested) → (Unheld, Requested)
- Attempting to unhold fails at the first attempt to acquire a resource: (Held, any reason) → (Pending_Unhold, Requested) → (Held, Resource_Not_Available)
- Attempting to unhold acquires one resource, but fails to acquire a second, and takes time to release the first: (Held, any reason) → (Pending_Unhold, Requested) → (Pending_Hold, Resource_Not_Available) → (Held, Resource_Not_Available)

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  hold

      A boolean indicating whether or not the channel should be on hold

  timeout | The timeout in milliseconds.

void Tp::Client::ChannelInterfaceHoldInterface::HoldStateChanged | ( | uint | holdState,
|  | uint | reason
| ) |  |

signal

Represents the signal `HoldStateChanged` on the remote object.

Emitted to indicate that the hold state has changed for this channel. This may occur as a consequence of you requesting a change with RequestHold, or the state changing as a result of a request from another process.

Parameters

  holdState

      The state of the channel

  reason

      The reason for the state change

void Tp::Client::ChannelInterfaceHoldInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.